
/* file mpn_macros.h
 * Macros to make it easier to work with the limbs of the mpz_t type 
 * See GMP documentation for the mpn functions.
 */

/* these macros are from GMP-ECM 6.01, file ecm-gmp.h */
/* They are also in gmp-impl.h of the GMP distribution */
#define PTR(x) ((x)->_mp_d)
#define SIZ(x) ((x)->_mp_size)
#define ALLOC(x) ((x)->_mp_alloc)
#define ABS(x) ((x) >= 0 ? (x) : -(x))
#define ABSIZ(x) ABS (SIZ (x))
#ifndef MPZ_REALLOC
#define MPZ_REALLOC(z,n) ((n) > ALLOC(z) ? _mpz_realloc(z,n) : PTR(z))
#endif

